using System;
using System.Collections.Generic;
using System.Text;

namespace AsynchCalcPi2005
{
    class AsyncCalcPiForm7_Thread6_Async4_Encap : AsyncCalcPiForm5_Thread4_Async2_Safe
    {
        public AsyncCalcPiForm7_Thread6_Async4_Encap()
            : base()
        {
            this.Text = "Thread:Async:Encap";
        }

        protected override bool ShowProgress(string pi, int totalDigits, int digitsSoFar)
        {
            if (this.InvokeRequired)
            {
                ShowProgressDelegate showProgressDel =
                    new ShowProgressDelegate(ShowProgress);
                return (bool) this.Invoke(
                    showProgressDel,
                    new object[] { pi.ToString(), totalDigits, digitsSoFar });
            }
            else
            {
                return base.ShowProgress(pi, totalDigits, digitsSoFar);
            }           
        }

        override protected void CalcPi(int digits)
        {
            StringBuilder pi = new StringBuilder("3", digits + 2);

            ShowProgress(pi.ToString(), digits, 0);
            if (digits > 0)
            {
                pi.Append(".");

                for (int i = 0; i < digits; i += 9)
                {
                    int nineDigits = NineDigitsOfPi.StartingAt(i + 1);
                    int digitCount = Math.Min(digits - i, 9);
                    string ds = string.Format("{0:D9}", nineDigits);
                    pi.Append(ds.Substring(0, digitCount));


                    if (!ShowProgress(pi.ToString(), digits, i + digitCount))
                    {
                        Console.WriteLine("Still going...");                        
                    }
                    
                }

            }
        }
    }
}
